//+------------------------------------------------------------------+
//|                                                  Welwitschia.mq4 |
//|                                                      |
//|                                            admin@solutionsfx.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2008"
#property link      "admin@solutionsfx.com"

//---- input parameters
string   EA_name = "WELWITSCHIA Expert Advisor";
extern   string   ExpertName = "Welwitschia EA";
extern   int      MagicNumber = 1234567;
bool     TickMode = true;
extern   double   Lots = 0.1;
int      Slippage = 3;
extern   bool     UseSL = true;
extern   int      SL = 70;
extern   bool     UseTP = true;
extern   int      TP = 30;
extern   bool     UseTS = false;
extern   int      TS = 20;
extern   bool     UseSound = true;
extern   string   FileSound = "alert.wav";
int      PrevBars;
int      Shift;
bool     var_188 = false;
string   EA_namesmall = "Welwitschia 1.0";
string   EA_email = "admin@solutionsfx.com";

//+------------------------------------------------------------------+

int init()
{
return(0);

PrevBars = Bars;
if (TickMode) Shift = 0; else Shift = 1;
return(0);
}

//+------------------------------------------------------------------+

int deinit()
{
return(0);
}

//+------------------------------------------------------------------+

int start()
{
if (CheckTodaysOrders() >= 20) return(0);       //CHANGED THE VALUE 1 TO 20 IN ORDER TO BE ABLE TO OPEN MORE THAN 1 TRADE A DAY
int signal = 0;

int    ordtotal;
int    ticket;
double sl;
double tp;

if (TickMode && (Bars != PrevBars)) var_188 = false;

ordtotal = OrdersTotal();
signal = 0;

bool find = false; 
for (int i = 0; i < ordtotal; i++)
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if ((OrderType() <= OP_SELL) && (OrderSymbol() == Symbol()))
   {
   
      find = true;
      if (OrderType() == OP_BUY)
         {
         if ((signal == 3) && ((TickMode && !var_188) || (!TickMode && (Bars != PrevBars))))
         {
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,MediumSeaGreen);
             if (!TickMode) PrevBars = Bars;
            find = false;
         }
            else
         {
         
         //TRAILING ROUTINE
            if (UseTS && (TS > 0))
              {
              if (Bid - OrderOpenPrice() > Point * TS)
                {
              if (OrderStopLoss() < Bid - Point * TS)
                {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Bid - Point * TS,OrderTakeProfit(),0,MediumSeaGreen);
                 if (!TickMode) PrevBars = Bars;
                }
                }
               }
            }
         }
            else
        {
         if ((signal == 4) && ((TickMode && !var_188) || (!TickMode && (Bars != PrevBars))))
            {
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,DarkOrange);
            if (!TickMode) PrevBars = Bars;
           find = false;
           }
               else
            {
            
            //TRAILING ROUTINE
            if (UseTS && (TS > 0))
               {
               if (OrderOpenPrice() - Ask > Point * TS)
                  {
                  if ((OrderStopLoss() > Ask + Point * TS) || (OrderStopLoss() == 0))
                     {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask + Point * TS,OrderTakeProfit(),0,DarkOrange);
                     if (!TickMode) PrevBars = Bars;
                     }
                  }
               }
            }
         }
      }
   }

//LOOK FOR UPTREND/BUY SIGNAL 
if (GlobalVariableGet(StringConcatenate(Symbol(),"GenCond"))==1)
{
 signal=1;
}

//LOOK FOR DOWNTREND/SELL SIGNAL
if (GlobalVariableGet(StringConcatenate(Symbol(),"GenCond"))==2)
{
 signal=2;
}

//OPEN BUY POSITION
if ((signal == 1) && ((TickMode && !var_188) || (!TickMode && (Bars != PrevBars))))
   {
   if (!find)
      {
      if (AccountFreeMargin() < Lots * 1000.0)
         {
         Print("Not enough money. Account free margin = ",AccountFreeMargin());
         return(0);
         }
     if (UseSL) sl = Ask - sl * Point; else sl = 0.0;
     if (UseTP) tp = Ask + tp * Point; else tp = 0.0;
      ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,sl,tp,"Welvitschia BUY",MagicNumber,0,DodgerBlue);
      if (ticket > 0)
         {
         if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            {
           if (UseSound) PlaySound(FileSound);
            }
               else
            {
            Print("Error opening buy order: ",GetLastError());
            }
         }
      if (TickMode) var_188 = true;
      if (!TickMode) PrevBars = Bars;
      return(0);
      }
   }

//OPEN SELL POSITION
if ((signal == 2) && ((TickMode && !var_188) || (!TickMode && (Bars != PrevBars))))
   {
   if (!find)
      {
      if (AccountFreeMargin() < Lots * 1000.0)
         {
         Print("Not enough money. Account free margin = ",AccountFreeMargin());
         return(0);
         }
      if (UseSL) sl = Bid + SL * Point; else sl = 0.0;
      if (UseTP) tp = Bid - TP * Point; else tp = 0.0;
      ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,sl,tp,"Welwitschia SELL",MagicNumber,0,DeepPink);
      if (ticket > 0)
         {
         if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            {
            if (UseSound) PlaySound(FileSound);
            }
               else
            {
            Print("Error opening sell order: ",GetLastError());
            }
         }
      if (TickMode) var_188 = true;
      if (!TickMode) PrevBars = Bars;
      return(0);
      }
   }

if (!TickMode) PrevBars = Bars;
}

//+------------------------------------------------------------------+

//CHECK TODAY ORDERS ROUTINE
int CheckTodaysOrders()
{
int cnt = 0;
for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if (TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())) cnt++;
   }
for (i = OrdersHistoryTotal() - 1; i >= 0; i--)
   {
   OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
   if (TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())) cnt++;
   }
return(cnt);
}